function [D] = CityBlockDistance(x,M1,M2,W)
% City block distance

% D ... array (M1xM1xN) of distances between ivth input vector and weight
% vectors of output neurons 

% City block distance between vector x and vector wj, dj = sum(abs(x-wj))
xM = repmat(x,[M1,1,M2]);
xM = permute(xM,[1,3,2]);
D = sum(abs(xM-W),3);
end