function [D] = Correlation(x,M1,M2,W,meanX,meanW,stdX,stdW)
% Correlation

% D ... array (M1xM1xN) of distances between ivth input vector and weight
% vectors of output neurons
  
% Correlation between vector x and vector wj, dj = sum(x*wj)
x = x - meanX;
W = W - repmat(meanW,M1,M2);
xM = repmat(x,[M1,1,M2]);
xM = permute(xM,[1,3,2]);
stdX = repmat(stdX,[M1,1,M2]);
stdX = permute(stdX,[1,3,2]);
D = sum(xM.*W./(stdX.*repmat(stdW,M1,M2)),3);
end