function [D] = DirectionCosines(x,M1,M2,W)
% Direction cosines

% D ... array (M1xM1xN) of distances between ivth input vector and weight
% vectors of output neurons

% normalization
x = x/sqrt(sum(x.^2));
normW = sqrt(sum(W.^2,3));
for i=1:size(W,3)
    W(:,:,i) = W(:,:,i) ./ normW;
end 
    
% Direction cosines between vector x and vector wj, dj = sum(x*wj)
xM = repmat(x,[M1,1,M2]);
xM = permute(xM,[1,3,2]);
D = sum(xM.*W,3);
end