function [D] = EuclideanDistance(x,M1,M2,W)
% Euclidean distance

% D ... array (M1xM1xN) of distances between ivth input vector and weight
% vectors of output neurons
  
% Euclidean distance between vector x and vector wj, dj = sum((x-wj).^2)
xM = repmat(x,[M1,1,M2]);
xM = permute(xM,[1,3,2]);
D = sum((xM-W).^2,3);
end