function [] = GUI()
close all; clear all; clc;

%% Nastaveni velikosti pisma, barvy pozadi 
velikostHlavnihoNadpisu = 18;
velikostVedlejsihoNadpisu = 12;
velikostNadpisu = 11;
velikostTextu = 9;
bgcolor = [240, 248, 255]...%173, 216, 230]...%219, 215, 210]
    *1/255;
bgcolor2 = [219, 215, 210]*1/255;

%% Hlavni okno
scrsz = get(0,'ScreenSize');
h = figure;
set(h,'Position',[10 50 scrsz(3)/2 scrsz(4)-100],'numbertitle','off','name','SOM','Color',bgcolor2);

%% SOM
titleSOM = uicontrol('Parent',h,'Style','Text','String','SOM',...
    'FontWeight','bold','HorizontalAlignmen','center','FontSize',velikostHlavnihoNadpisu,...
    'units','Normalized','Position',[.0 .9 1 .08],'Backgroundcolor',bgcolor2);

%% Structure of Network

titleStructureOfNetwork = uicontrol('Parent',h,'Style','Text','String','Structure of Network',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostVedlejsihoNadpisu,...
    'units','Normalized','Position',[.05 .89 .9 .04],'Backgroundcolor',bgcolor2);

titleInputLayer = uicontrol('Parent',h,'Style','Text','String','Input layer:',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostNadpisu,...
    'units','Normalized','Position',[.1 .88 .1 .02],'Backgroundcolor',bgcolor2);
   textInputLayer = uicontrol('Parent',h,'Style','Text','String','Location of file with input data:',...
    'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
    'units','Normalized','Position',[.21 .88 .2 .02],'Backgroundcolor',bgcolor2); 
           editInputLayer = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.4 .885 .1 .02],'Backgroundcolor',bgcolor); 

titleOutputLayer = uicontrol('Parent',h,'Style','Text','String','Output layer:',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostNadpisu,...
    'units','Normalized','Position',[.1 .85 .1 .02],'Backgroundcolor',bgcolor2);
   textOutputLayer1 = uicontrol('Parent',h,'Style','Text','String','Horizontal size of output layer:',...
    'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
    'units','Normalized','Position',[.21 .85 .2 .02],'Backgroundcolor',bgcolor2); 
           editOutputLayer1 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.4 .855 .05 .02],'Backgroundcolor',bgcolor); 
   textOutputLayer2 = uicontrol('Parent',h,'Style','Text','String','Vertical size of output layer:',...
    'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
    'units','Normalized','Position',[.21 .83 .2 .02],'Backgroundcolor',bgcolor2); 
           editOutputLayer2 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.4 .835 .05 .02],'Backgroundcolor',bgcolor); 

%% Learning

titleLearning = uicontrol('Parent',h,'Style','Text','String','Learning',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostVedlejsihoNadpisu,...
    'units','Normalized','Position',[.05 .75 .9 .04],'Backgroundcolor',bgcolor2);

textNumberOfEpochs = uicontrol('Parent',h,'Style','Text','String','Number of epochs:',...
    'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
    'units','Normalized','Position',[.1 .74 .2 .02],'Backgroundcolor',bgcolor2);
           editNumberOfEpochs = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.23 .745 .05 .02],'Backgroundcolor',bgcolor); 

% BETA
titleSettingOfLearningParameter = uicontrol('Parent',h,'Style','Text','String','Setting of learning parameter:',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostNadpisu,...
    'units','Normalized','Position',[.1 .71 .3 .02],'Backgroundcolor',bgcolor2);
    textSettingOfLearningParameter1 = uicontrol('Parent',h,'Style','Text','String','Initial value of learning parameter:',...
     'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
     'units','Normalized','Position',[.15 .685 .3 .02],'Backgroundcolor',bgcolor2);
           editSettingOfLearningParameter1 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.43 .69 .05 .02],'Backgroundcolor',bgcolor); 
    textSettingOfLearningParameter2 = uicontrol('Parent',h,'Style','Text','String','Final value of learning parameter:',...
     'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
     'units','Normalized','Position',[.15 .665 .3 .02],'Backgroundcolor',bgcolor2);
           editSettingOfLearningParameter2 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.43 .67 .05 .02],'Backgroundcolor',bgcolor); 
    textSettingOfLearningParameter3 = uicontrol('Parent',h,'Style','Text','String','In which part of learning process the learning parameter reaches the final value:',...
     'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
     'units','Normalized','Position',[.15 .625 .3 .04],'Backgroundcolor',bgcolor2);
           editSettingOfLearningParameter3 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.43 .64 .05 .02],'Backgroundcolor',bgcolor); 
uibuttongroupSettingOfLP = uibuttongroup('Parent',h,'Title','Setting of learning rate decay',...
    'FontWeight','normal','FontSize',velikostTextu,...
    'units','Normalized','Position',[.6 .63 .3 .1],...
    'visible','on','Backgroundcolor',bgcolor2,'SelectionChangeFcn',@LPSelectionChangeFcn);
    % Create three radio buttons in the button group.
    LPdecayNoDecay = uicontrol('Style','Radio','String','No decay',...
        'units','Normalized','Position',[.1 .7 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfLP,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    LPdecayLinear = uicontrol('Style','Radio','String','Linear decay',...
        'units','Normalized','Position',[.1 .45 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfLP,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    LPdecayExponential = uicontrol('Style','Radio','String','Exponential decay',...
        'units','Normalized','Position',[.1 .2 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfLP,'HandleVisibility','on','Backgroundcolor',bgcolor2);

% SIGMA        
titleSettingOfNeighbourhood = uicontrol('Parent',h,'Style','Text','String','Setting of neighbourhood:',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostNadpisu,...
    'units','Normalized','Position',[.1 .58 .3 .02],'Backgroundcolor',bgcolor2);
    textSettingOfNeighbourhood1 = uicontrol('Parent',h,'Style','Text','String','Initial value of neighbourhood size:',...
     'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
     'units','Normalized','Position',[.15 .555 .3 .02],'Backgroundcolor',bgcolor2);
           editSettingOfNeighbourhood1 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.43 .56 .05 .02],'Backgroundcolor',bgcolor); 
    textSettingOfNeighbourhood2 = uicontrol('Parent',h,'Style','Text','String','Final value of neighbourhood size:',...
     'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
     'units','Normalized','Position',[.15 .535 .3 .02],'Backgroundcolor',bgcolor2);
           editSettingOfNeighbourhood2 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.43 .54 .05 .02],'Backgroundcolor',bgcolor); 
    textSettingOfNeighbourhood3 = uicontrol('Parent',h,'Style','Text','String','In which part of learning process the neighbourhood size reaches the final value:',...
     'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
     'units','Normalized','Position',[.15 .495 .3 .04],'Backgroundcolor',bgcolor2);
           editSettingOfNeighbourhood3 = uicontrol('Parent',h,'Style','Edit','String','',...
            'FontWeight','normal','HorizontalAlignmen','center','FontSize',velikostTextu,...
            'units','Normalized','Position',[.43 .51 .05 .02],'Backgroundcolor',bgcolor);   
uibuttongroupSettingOfNS = uibuttongroup('Parent',h,'Title','Setting of neighbourhood size decay',...
    'FontWeight','normal','FontSize',velikostTextu,...
    'units','Normalized','Position',[.6 .5 .3 .1],...
    'visible','on','Backgroundcolor',bgcolor2,'SelectionChangeFcn',@NSSelectionChangeFcn);
    % Create three radio buttons in the button group.
    NSdecayNoDecay = uicontrol('Style','Radio','String','No decay',...
        'units','Normalized','Position',[.1 .7 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfNS,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayLinear = uicontrol('Style','Radio','String','Linear decay',...
        'units','Normalized','Position',[.1 .45 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfNS,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayExponential = uicontrol('Style','Radio','String','Exponential decay',...
        'units','Normalized','Position',[.1 .2 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfNS,'HandleVisibility','on','Backgroundcolor',bgcolor2);
uibuttongroupSettingOfNS2 = uibuttongroup('Parent',h,'Title','Setting of neighbourhoodsize strength function',...
    'FontWeight','normal','FontSize',velikostTextu,...
    'units','Normalized','Position',[.15 .37 .36 .12],...
    'visible','on','Backgroundcolor',bgcolor2,'SelectionChangeFcn',@NS2SelectionChangeFcn);
    NSdecayNoDecay = uicontrol('Style','Radio','String','Constant function',...
        'units','Normalized','Position',[.1 .8 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfNS2,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayLinear = uicontrol('Style','Radio','String','Linear function',...
        'units','Normalized','Position',[.1 .6 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfNS2,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayGaussian = uicontrol('Style','Radio','String','Gaussian function',...
        'units','Normalized','Position',[.1 .4 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfNS2,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayExponential = uicontrol('Style','Radio','String','Exponential function',...
        'units','Normalized','Position',[.1 .2 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfNS2,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    
% W
titleSettingOfWeights = uicontrol('Parent',h,'Style','Text','String','Setting of weights:',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostNadpisu,...
    'units','Normalized','Position',[.1 .33 .3 .02],'Backgroundcolor',bgcolor2);
uibuttongroupSettingOfW = uibuttongroup('Parent',h,'Title','Type of weights initialization',...
    'FontWeight','normal','FontSize',velikostTextu,...
    'units','Normalized','Position',[.15 .22 .36 .1],...
    'visible','on','Backgroundcolor',bgcolor2,'SelectionChangeFcn',@WSelectionChangeFcn);
    % Create three radio buttons in the button group.
    W1 = uicontrol('Style','Radio','String','Random small numbers',...
        'units','Normalized','Position',[.1 .7 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfW,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    W2 = uicontrol('Style','Radio','String','Random numbers from the center of input space',...
        'units','Normalized','Position',[.1 .45 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfW,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    W3 = uicontrol('Style','Radio','String','Randomly choose some input vectors',...
        'units','Normalized','Position',[.1 .2 .9 .2],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfW,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    
% distance measures
titleSettingOfDistanceMeasure = uicontrol('Parent',h,'Style','Text','String','Setting of distance measure:',...
    'FontWeight','bold','HorizontalAlignmen','left','FontSize',velikostNadpisu,...
    'units','Normalized','Position',[.1 .18 .3 .02],'Backgroundcolor',bgcolor2);
uibuttongroupSettingOfDM = uibuttongroup('Parent',h,'Title','Setting of neighbourhoodsize strength function',...
    'FontWeight','normal','FontSize',velikostTextu,...
    'units','Normalized','Position',[.15 .05 .36 .12],...
    'visible','on','Backgroundcolor',bgcolor2,'SelectionChangeFcn',@DMSelectionChangeFcn);
    NSdecayNoDecay = uicontrol('Style','Radio','String','Euclidean distance',...
        'units','Normalized','Position',[.1 .8 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfDM,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayLinear = uicontrol('Style','Radio','String','Correlation',...
        'units','Normalized','Position',[.1 .6 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfDM,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayGaussian = uicontrol('Style','Radio','String','Direction cosine',...
        'units','Normalized','Position',[.1 .4 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfDM,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    NSdecayExponential = uicontrol('Style','Radio','String','City block distance',...
        'units','Normalized','Position',[.1 .2 .9 .15],...
        'FontWeight','normal','HorizontalAlignmen','left','FontSize',velikostTextu,...
        'parent',uibuttongroupSettingOfDM,'HandleVisibility','on','Backgroundcolor',bgcolor2);
    
%% Run SOM
buttonRunSOM = uicontrol('Parent',h,'Style','Pushbutton','String','Run SOM',...
    'FontWeight','bold','HorizontalAlignmen','center','FontSize',velikostNadpisu,...
    'units','Normalized','Position',[.82 .02 .16 .04],'Backgroundcolor',bgcolor2,...
    'callback',@callbackFuncSOM);

%%

function [] = callbackFuncSOM(hObject, eventdata)
    % Location of file with input data
    userInputData = get(editInputLayer, 'String');
    % Vertical size of output layer
    userM1 = str2double(get(editOutputLayer2, 'String'));
    % Horizontal size of output layer
    userM2 = str2double(get(editOutputLayer1, 'String'));
    % Number of epochs
    userEpoch = str2double(get(editNumberOfEpochs, 'String'));
    % Inital value of learning parameter
    userBETAinit = str2double(get(editSettingOfLearningParameter1, 'String')); 
    % Final value of learning parameter
    userBETAfinal = str2double(get(editSettingOfLearningParameter2, 'String')); 
    % In which part of learning process the learning parameter reaches the final value
    userBETAtime = str2double(get(editSettingOfLearningParameter3, 'String')); 
    % Inital value of neighbourhood size
    userSIGMAinit = str2double(get(editSettingOfNeighbourhood1, 'String')); 
    % Final value of neighbourhood size
    userSIGMAfinal = str2double(get(editSettingOfNeighbourhood2, 'String')); 
    % In which part of learning process the neighbourhood size reaches the final value
    userSIGMAtime = str2double(get(editSettingOfNeighbourhood3, 'String')); 
    % Setting of learning rate decay
    if strcmp(get(get(uibuttongroupSettingOfLP,'SelectedObject'),'String'),'No decay')
        userLearningRateDecay = 1;
    elseif strcmp(get(get(uibuttongroupSettingOfLP,'SelectedObject'),'String'),'Linear decay')
        userLearningRateDecay = 2;
    elseif strcmp(get(get(uibuttongroupSettingOfLP,'SelectedObject'),'String'),'Exponential decay')
        userLearningRateDecay = 3;
    end
    % Setting of neighbourhood size decay
    if strcmp(get(get(uibuttongroupSettingOfNS,'SelectedObject'),'String'),'No decay')
        userShrinkingNeighborhood = 1;
    elseif strcmp(get(get(uibuttongroupSettingOfNS,'SelectedObject'),'String'),'Linear decay')
        userShrinkingNeighborhood = 2;
    elseif strcmp(get(get(uibuttongroupSettingOfNS,'SelectedObject'),'String'),'Exponential decay')
        userShrinkingNeighborhood = 3;
    end
    % Setting of neighbourhoodsize strength function
    if strcmp(get(get(uibuttongroupSettingOfNS2,'SelectedObject'),'String'),'Constant function')
        userNeighborStrength = 1;
    elseif strcmp(get(get(uibuttongroupSettingOfNS2,'SelectedObject'),'String'),'Linear function')
        userNeighborStrength = 2;
    elseif strcmp(get(get(uibuttongroupSettingOfNS2,'SelectedObject'),'String'),'Gaussian function')
        userNeighborStrength = 3;
    elseif strcmp(get(get(uibuttongroupSettingOfNS2,'SelectedObject'),'String'),'Exponential function')
        userNeighborStrength = 4;
    end
    % Type of weights initialization
    if strcmp(get(get(uibuttongroupSettingOfW,'SelectedObject'),'String'),'Random small numbers')
        userInitWeight = 1;
    elseif strcmp(get(get(uibuttongroupSettingOfW,'SelectedObject'),'String'),'Random numbers from the center of input space')
        userInitWeight = 2;
    elseif strcmp(get(get(uibuttongroupSettingOfW,'SelectedObject'),'String'),'Randomly choose some input vectors')
        userInitWeight = 3;
    end
    % Setting of distance measure
    if strcmp(get(get(uibuttongroupSettingOfDM,'SelectedObject'),'String'),'Euclidean distance')
        userDistanceMeasure = 1;
    elseif strcmp(get(get(uibuttongroupSettingOfDM,'SelectedObject'),'String'),'Correlation')
        userDistanceMeasure = 2;
    elseif strcmp(get(get(uibuttongroupSettingOfDM,'SelectedObject'),'String'),'Direction cosine')
        userDistanceMeasure = 3;
    elseif strcmp(get(get(uibuttongroupSettingOfDM,'SelectedObject'),'String'),'City block distance')
        userDistanceMeasure = 4;
    end
    SOM_GUI(userM1,userM2,userInputData,userInitWeight,userBETAinit,userBETAfinal,userBETAtime,userSIGMAinit,userSIGMAfinal,userSIGMAtime,...
    userDistanceMeasure,userLearningRateDecay,userNeighborStrength,userShrinkingNeighborhood,userEpoch) 
end


function LPSelectionChangeFcn(source,eventdata)
    % disp(source);
    % disp([eventdata.EventName,'  ',... 
    %      get(eventdata.OldValue,'String'),'  ', ...
    %      get(eventdata.NewValue,'String')]);
    % disp(get(get(source,'SelectedObject'),'String'));
    if strcmp(get(get(source,'SelectedObject'),'String'),'No decay')
        userLearningRateDecay = 1;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Linear decay')
        userLearningRateDecay = 2;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Exponential decay')
        userLearningRateDecay = 3;
    end
    disp(userLearningRateDecay);
end

function NSSelectionChangeFcn(source,eventdata)
    % disp(source);
    % disp([eventdata.EventName,'  ',... 
    %      get(eventdata.OldValue,'String'),'  ', ...
    %      get(eventdata.NewValue,'String')]);
    % disp(get(get(source,'SelectedObject'),'String'));
    if strcmp(get(get(source,'SelectedObject'),'String'),'No decay')
        userShrinkingNeighborhood = 1;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Linear decay')
        userShrinkingNeighborhood = 2;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Exponential decay')
        userShrinkingNeighborhood = 3;
    end
    disp(userShrinkingNeighborhood);
end

function NS2SelectionChangeFcn(source,eventdata)
    % disp(source);
    % disp([eventdata.EventName,'  ',... 
    %      get(eventdata.OldValue,'String'),'  ', ...
    %      get(eventdata.NewValue,'String')]);
    % disp(get(get(source,'SelectedObject'),'String'));
    if strcmp(get(get(source,'SelectedObject'),'String'),'Constant function')
        userNeighborStrength = 1;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Linear function')
        userNeighborStrength = 2;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Gaussian function')
        userNeighborStrength = 3;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Exponential function')
        userNeighborStrength = 4;
    end
    disp(userNeighborStrength);
end

function WSelectionChangeFcn(source,eventdata)
    % disp(source);
    % disp([eventdata.EventName,'  ',... 
    %      get(eventdata.OldValue,'String'),'  ', ...
    %      get(eventdata.NewValue,'String')]);
    % disp(get(get(source,'SelectedObject'),'String'));
    if strcmp(get(get(source,'SelectedObject'),'String'),'Random small numbers')
        userInitWeight = 1;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Random numbers from the center of input space')
        userInitWeight = 2;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Randomly choose some input vectors')
        userInitWeight = 3;
    end
    disp(userInitWeight);
end

function DMSelectionChangeFcn(source,eventdata)
    % disp(source);
    % disp([eventdata.EventName,'  ',... 
    %      get(eventdata.OldValue,'String'),'  ', ...
    %      get(eventdata.NewValue,'String')]);
    % disp(get(get(source,'SelectedObject'),'String'));
    if strcmp(get(get(source,'SelectedObject'),'String'),'Euclidean distance')
        userDistanceMeasure = 1;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Correlation')
        userDistanceMeasure = 2;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'Direction cosine')
        userDistanceMeasure = 3;
    elseif strcmp(get(get(source,'SelectedObject'),'String'),'City block distance')
        userDistanceMeasure = 4;
    end
    disp(userDistanceMeasure);
end

end