function [SUMdist, Nclass, Xclass] = convergence(IV,X,M1,M2,W)
% convergence

%SUMdist ... sum of distances between input vectors and weight vectors at the end of the epoch
SUMdist = zeros(M1,M2);
%Nclass ... number of input vectors belonging to class (neuron of output layer) m1, m2
Nclass = zeros(M1,M2);
% priradeni input vektoru k jednotlivym clusterum
Xclass = zeros(size(X,1),2);
% for each input vector do
for iv=1:IV
    % 1) predlozeni vzoru
    %x ... one input vector
    x = X(iv,:);
    %==================================================================
    % 2) calculation of distances between input vector and
    % weight vectors of output neurons
    %==================================================================
    % D ... matrix of distances between ivth input vector and weight vectors of
    % output neurons
        
    %------------------------------------------------------------------        
    % Distance measures
    %------------------------------------------------------------------
    %Euclidean distance
    %-------------------
    D = EuclideanDistance(x,M1,M2,W);
    % the smallest distance = the winner (min)
            
    %==================================================================
    %3) selection of the nearest (the most similar) neuron
    %==================================================================
    % according to distance measure
    %Euclidean distance
    %-------------------
    % the smallest distance = the winner (min)
    [m1,m2] = BMUmin(D);
    SUMdist(m1,m2) = SUMdist(m1,m2) + D(m1,m2);
    Nclass(m1,m2) = Nclass(m1,m2) + 1;
    Xclass(iv,:) = [m1,m2];
end
