function [Wvect, con, classDist, classN, classX] = learning(Epoch,DistanceMeasure,LearningRateDecay,NeighborStrength,ShrinkingNeighborhood,IV,X,M1,M2,W, BETAinit,BETAfinal,BETAtime,SIGMAinit,SIGMAfinal,SIGMAtime,N)
% learning

%Recursive
%Batch learning

% con ... mean distance = suma i(suma n(xn-wi)^2)), nth input vector belonging to cluster i,   vector of sums of distances between input vectors and weight vectors of winner neuron at the end of each epoch
con = zeros(Epoch,1);
% Wvect = zeros(size(W),Epoch);
% classN ... number of input vectors belonging to class (neuron of output layer) m1, m2
classN = zeros(M1,M2, Epoch);
% classDist ... chyba v ramci tridy
classDist = zeros(M1,M2,Epoch);
% priradeni input vektoru k jednotlivym clusterum
classX = zeros(size(X,1),2,Epoch);

% for correlation calculations
meanX = mean(X);
meanW = mean(mean(W));
stdX = std(X,1);
stdW = std(std(W,1));

% epoch ... number of epochs
for e=1:Epoch
    disp(e);
    % for each input vector do
    for iv=1:IV
        %==================================================================        
        % 1) predlozeni vzoru
        %==================================================================        
        %x ... one input vector
        x = X(iv,:);
        
        %==================================================================
        % 2) calculation of distances between input vector and
        % weight vectors of output neurons
        %==================================================================
        % D ... matrix of distances between ivth input vector and weight vectors of
        % output neurons
        
        %------------------------------------------------------------------        
        % Distance measures
        %------------------------------------------------------------------
        if DistanceMeasure==1
            %Euclidean distance
            %-------------------
            D = EuclideanDistance(x,M1,M2,W);
            % the smallest distance = the winner (min)
            
        elseif DistanceMeasure==2
            % Correlation
            %-------------
            D = Correlation(x,M1,M2,W,meanX,meanW,stdX,stdW);   
            % the highest the correlation = the winner (max)
            
        elseif DistanceMeasure==3
            % Direction cosines
            %-------------------
            D = DirectionCosines(x,M1,M2,W);  
            % the largest cosine = the winner (max)
            
        elseif DistanceMeasure==4
            % City block distance
            %---------------------
            D = CityBlockDistance(x,M1,M2,W);            
            % the smallest distance = the winner (min)
        end
        
        %==================================================================
        %3) selection of the nearest (the most similar) neuron
        %==================================================================
        % according to distance measure
        if DistanceMeasure==1
            %Euclidean distance
            %-------------------
            % the smallest distance = the winner (min)
            [m1,m2] = BMUmin(D);
            
        elseif DistanceMeasure==2
            % Correlation
            %------------- 
            % the highest the correlation = the winner (max)
            [m1,m2] = BMUmax(D);            
            
        elseif DistanceMeasure==3
            % Direction cosines
            %-------------------
            % the largest cosine = the winner (max)
            [m1,m2] = BMUmax(D);            
            
        elseif DistanceMeasure==4
            % City block distance
            %---------------------         
            % the smallest distance = the winner (min)
            [m1,m2] = BMUmin(D);            
        end
        
        %==================================================================         
        %4) adjustment of weights
        %==================================================================
        W = adjustment(LearningRateDecay,NeighborStrength,ShrinkingNeighborhood,BETAinit,BETAfinal,BETAtime,SIGMAinit,SIGMAfinal,SIGMAtime,iv,e,Epoch,IV,x,M1,M2,N,m1,m2,W);

        % convergence of SOM
        %5) konec?
    end
    [SUMdist, Nclass, Xclass] = convergence(IV,X,M1,M2,W);
    con(e,1) = sum(sum(SUMdist));
    Wvect(:,:,:,e) = W;
    classDist(:,:,e) = SUMdist./Nclass;
    classN(:,:,e) = Nclass;
    classX(:,:,e) = Xclass;
end

% % save vector con to file 
% confilename = 'con_v3';
% csvwrite(confilename,con);


end