function [] = visualizationXW(N,X,W, figureNumber)
% Visualization of input data and weights

% combinations ... all 2-combinations from a given set (input data) of N
% elements
combinations = nchoosek(1:N,2); 
numberOfCombinations = size(combinations);
numberOfCombinations = numberOfCombinations(1,1);

% figure
f1 = figure(figureNumber);
clf; % clear current figure window
set(f1,'Name', 'Initial random weight vectors superimposed on data','NumberTitle','on','Units','Normal','Position',[0.01,0.0,0.4,0.5]);

% for each combination one subplot
for i = 1:numberOfCombinations
    
    % define division of plot to subplots
    if (numberOfCombinations/4)>1
        subplot(((numberOfCombinations-mod(numberOfCombinations,4))/4+1),4,i)
    else
        subplot(1,numberOfCombinations,i);
    end
    
    % plot input data
    plotData = plot(X(:,combinations(i,1)), (X(:,combinations(i,2))), '*');
    set(plotData,'Color','black');
    hold on;
    
    % plot weights
    x = W(:,:,combinations(i,1));
    y = W(:,:,combinations(i,2));
    plotWeights = plot(x(:), y(:), '+');
    set(plotWeights,'Color','red');
    
    % xlabel, legend of subplot
    xlabel(['x_',num2str(combinations(i,1))]); ylabel(['x_',num2str(combinations(i,2))]);
    grid on;
    %title('Initial random weight vectors superimposed on data');
    if i==numberOfCombinations
        legend('Data.','Weights (position of cluster centers)','Location','southOutside')
    end
end
hold off;